
var prevDirection = 0;
var prevMode = 0;

function IkePolInitialSettings ()
	{
    prevDirection = comboSelectedValueGet ('selDirection');
    prevMode = comboSelectedValueGet ('selExchangeType');
	
	localIdentTypeCheck ();
	remoteIdentTypeCheck ();
    modeCfgStatusCheckWrap ();
    comboValueSet ('selExchangeType', prevMode);
    return;
  	}
function modeCfgStatusCheck (modeCfgValue)
 {
  if (modeCfgValue == null) return;
  var hrefObj = document.getElementById('hrefViewModeCfgRec');
  switch (modeCfgValue) 
  	{
  	case 0: /* NO */
  		fieldStateChangeWr ('selModeConfigRecord btnViewSelected selxAuthConfigAuthType','','selDirection','');
  		comboValueSet ('selDirection', prevDirection);

/*
modified May 11 2007 (Start)
*/
  		fieldStateChangeWr ('btnViewSelected selxAuthConfigAuthType','','selExchangeType','');
  		comboValueSet ('selExchangeType', prevMode);

/*
modified May 11 2007 (End)
*/

		if (hrefObj)
			hrefObj.onclick = function () {return false;};
  		break;
  	case 1: /* YES */
  	    prevDirection = comboSelectedValueGet ('selDirection');
  	    prevMode = comboSelectedValueGet ('selExchangeType');
  		comboValueSet ('selDirection', 1);
  		fieldStateChangeWr ('selDirection','','selModeConfigRecord btnViewSelected selxAuthConfigAuthType','');

/*
modified May 11 2007 (Start)
*/
  		fieldStateChangeWr ('btnViewSelected selxAuthConfigAuthType','','selExchangeType','');
  		comboValueSet ('selExchangeType', 1);

/*
modified May 11 2007 (End)
*/


		if (hrefObj)
			hrefObj.onclick = function () {return true;};
  		break;
  	}
    xauthStatusCheckWrap ();
  }

function xauthStatusCheck (xauthStatus)
	{
	if (xauthStatus == null) return;
	switch (xauthStatus)
		{
		case 0: /* None */
			fieldStateChangeWr ('txtxAuthConfigUserName txtxAuthConfigPasswd selxAuthConfigAuthType','','','');
			break;
		case 1: /* Edge Device */
			fieldStateChangeWr ('txtxAuthConfigUserName txtxAuthConfigPasswd','','selxAuthConfigAuthType','');
			break; 
		case 2: /* IPSEC Host */
			fieldStateChangeWr ('selxAuthConfigAuthType','','txtxAuthConfigUserName txtxAuthConfigPasswd','');
			break; 
		}
	}

function localIdentTypeCheck ()
	{
	var selValue = comboSelectedValueGet ('selLocalIdentifier');
	if (selValue == null) return;
	switch (parseInt (selValue, 10))
		{
		case 0:	/* LOCAL ID */
            fieldStateChangeWr ('txtAddIkeLocId', '', '', '');
            break;
		default:
			fieldStateChangeWr ('', '', 'txtAddIkeLocId', '');
			break;
		}
	return;
	}

function remoteIdentTypeCheck ()
	{
	var selValue = comboSelectedValueGet ('selRemoteIdentifier');
	if (selValue == null) return;
	switch (parseInt (selValue, 10))
		{
		case 0:	/* REMOTE ID */
			fieldStateChangeWr ('txtAddIkePeerID', '', '', '');
            break;
		default:
			fieldStateChangeWr ('', '', 'txtAddIkePeerID', '');
			break;
		}
	return;
	}

function ikePolValidate ()
    {
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtAddIkePolName," +
                       "Please enter a name for the IKE policy";
    txtFieldIdArr[1] = "txtAddIkeLocId," +
                       "Please enter a valid local identifier";
    txtFieldIdArr[2] = "txtAddIkePeerID," +
                       "Please enter a valid peer identifier";
    txtFieldIdArr[3] = "txtPresharedKey," +
                       "Please enter the pre-shared key for this connection";
    txtFieldIdArr[4] = "txtxAuthConfigUserName," + 
                       "Please enter a valid XAUTH user name";
    txtFieldIdArr[5] = "txtxAuthConfigPasswd," + 
                       "Please enter a valid XAUTH password";
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
    var result = false;
    result = fieldLengthCheck ('txtPresharedKey', 8, 49,
                               'Invalid pre-shared key: Please enter key with length between 8 - 49 characters');   
    if (result == false)
        return false;
    var saIkeLifeTimeObj = document.getElementById('txtAddIkePolLifeTime');
    if (!saIkeLifeTimeObj || saIkeLifeTimeObj.disabled) return true;
    if (numericValueRangeCheck (saIkeLifeTimeObj, 1, 
                                "Please enter the life-time in seconds for the security association created by this policy",
                                '', '', false, "", "") == false)
         return false;

	obj = document.getElementById('txtDetectionPeriod');
	if (numericValueRangeCheck (obj , 1, 
                            "Invalid Detection Period - Please enter a value between 10-999",
                            10, 999, true, "Invalid Detection Period -", "") == false)
	return false; 

	obj = document.getElementById('txtReconnectCount');
	if (numericValueRangeCheck (obj , 1, 
                            "Invalid Reconnect after failure count - Please enter a value between 3-99",
                            3, 99, true, "Invalid Reconnect after failure count -", "") == false)
	return false; 

    /* enable dependent stuff if modeconfig is enabled */
    var exchTypeObj = document.getElementById('selExchangeType');
    if (!exchTypeObj) return;

        {
        var objIdArr = new Array ();
        objIdArr[0] = 'selExchangeType';
        objIdArr[1] = 'selLocalIdentifier';
        objIdArr[2] = 'selRemoteIdentifier';
        objIdArr[3] = 'selDirection';
        for (var i = 0; i < objIdArr.length; ++i)
            {
            var obj = document.getElementById(objIdArr[i]);
            if (obj)
                 obj.disabled = false;
            }
        }
    return true;
    }
